"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerConstructor = exports.RELEASE_DATE = exports.LICENSE_STATE = exports.UPGRADE_WINDOW = exports.OS_LICENSE_KEYS = exports.elementConstructors = exports.costructorTypes = exports.formElements = exports.buttons = exports.groups = exports.fields = exports.licensePlateStyle = exports.licensePlateClass = exports.PACKAGE_LICENSE_URL = void 0;
const utils_1 = require("./utils");
exports.PACKAGE_LICENSE_URL = '#';
exports.licensePlateClass = '#';
exports.licensePlateStyle = 'position: fixed !important; font-weight: bold; font-size: .8rem;  bottom: 1rem !important;  left: 1rem !important;  background: #fff;  border: 2px solid red;  padding: .5rem;  border-radius: 0.15rem;  z-index: 99999 !important;  display: inline-flex !important;  align-items: center;  color: red;  text-decoration: none;  transition: 0.2s linear;';
exports.fields = [];
exports.groups = [];
exports.buttons = [];
exports.formElements = [];
exports.costructorTypes = {
    field: 'field',
    group: 'group',
    button: 'button',
};
exports.elementConstructors = {};
exports.OS_LICENSE_KEYS = ['GPL-My-Project-Is-Open-Source', 'CC-Attribution-NonCommercial-NoDerivatives'];
exports.UPGRADE_WINDOW = 365 + 7;
exports.LICENSE_STATE = {
    VALID: 1,
    OUTDATED: 2,
    INVALID: 3,
};
exports.RELEASE_DATE = '2023-09-23';
const registerConstructor = (type, constructor, constructorT, licensed = false) => {
    switch (constructorT) {
        case exports.costructorTypes.button:
            exports.buttons.push(type);
            break;
        case exports.costructorTypes.group:
            exports.groups.push(type);
            break;
        case exports.costructorTypes.field:
            exports.fields.push(type);
            break;
    }
    if (licensed)
        (0, utils_1.useLicensedFetures)();
    exports.elementConstructors[type] = constructor;
};
exports.registerConstructor = registerConstructor;
