import { Form } from './form.js';
import { FieldValue, HTMLElementEvent } from './types.js';
import { FieldOptions } from './interfaces.js';
export declare class Field {
    options: FieldOptions;
    inputElement: HTMLElement | null;
    containerElement: HTMLElement | null;
    labelElement: HTMLElement | null;
    validationElement: HTMLElement | null;
    hasScheme: boolean;
    private _id;
    private _parent;
    private _form;
    private _isValid;
    private _isDisabled;
    private _isRequired;
    private _isMounted;
    private _isVisible;
    private _saveKey;
    private _vMessage;
    private _value;
    private _type;
    constructor(parent: HTMLElement, form: Form, options: FieldOptions);
    initializeOptions(options: FieldOptions): void;
    initialize(): Promise<void>;
    setValue(value: FieldValue, save?: boolean): void;
    syncValue(): void;
    getValue(): FieldValue;
    getId(): string;
    getSaveKey(): string;
    getType(): string;
    getVisibility(): boolean;
    getValidity(): boolean | null;
    isDisabled(): boolean;
    getValidationMessage(): string | null;
    getForm(): Form;
    createContainerElement(): void;
    createInputElement(): void;
    createLabelElement(): void;
    createValidationElement(): void;
    onGui(): void;
    private mount;
    private unmount;
    destroy(): void;
    handleValidatedField(): void;
    handleVisibility(): void;
    handleDisabled(): void;
    handleRequired(): void;
    bindChange(): void;
    save(): void;
    load(): void;
    reset(): Promise<void>;
    update(): Promise<void>;
    private updateVisibilityBasedOnConditions;
    private updateDisabledStatus;
    private updateRequiredStatus;
    validate(): boolean;
    change(event: HTMLElementEvent<HTMLInputElement>): void;
}
