"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordField = void 0;
const field_js_1 = require("../field.js");
class PasswordField extends field_js_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: 'password',
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return 'This field is required';
                return true;
            },
            default: null,
            className: 'form-input',
        };
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
}
exports.PasswordField = PasswordField;
