"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelField = void 0;
const field_js_1 = require("../field.js");
class TelField extends field_js_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: 'tel',
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return 'This field is required';
                if (value && typeof value === 'string' && !value.match(this._telFormat))
                    return 'Not a valid telephone number.';
                return true;
            },
            default: null,
            className: 'form-input',
        };
        this._telFormat = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
}
exports.TelField = TelField;
