import { Form } from './form.js';
import { RowOptions } from './interfaces.js';
export declare class Row {
    options: RowOptions;
    containerElement: HTMLElement | null;
    labelElement: HTMLElement | null;
    rowElement: HTMLElement | null;
    private _id;
    private _parent;
    private _form;
    private _isMounted;
    private _isVisible;
    private _type;
    constructor(parent: HTMLElement, form: Form, options: RowOptions);
    initializeOptions(options: RowOptions): void;
    initialize(): Promise<void>;
    getId(): string;
    getContainer(): HTMLElement | null;
    getRow(): HTMLElement | null;
    getType(): string;
    getVisibility(): boolean;
    createContainerElement(): void;
    createRowElement(): void;
    createLabelElement(): void;
    onGui(): void;
    private mount;
    private unmount;
    destroy(): void;
    handleVisibility(): void;
    reset(): Promise<void>;
    update(): Promise<void>;
    private updateVisibilityBasedOnConditions;
}
