import { Field } from '../field.js';
export class EmailField extends Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: 'text',
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return 'This field is required';
                if (value && typeof value === 'string' && !value.match(this._mailFormat))
                    return 'Not a valid email address.';
                return true;
            },
            default: null,
            className: 'form-input',
        };
        this._mailFormat = /^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
}
