import { FormOptions } from './interfaces.js';
import { FieldValue, Schema, FormData } from './types.js';
export declare class Form {
    options: FormOptions;
    private _parent;
    private _formElement;
    private _id;
    private _isValid;
    private _errors;
    private _fields;
    private _groups;
    private _buttons;
    private _data;
    private _saveProgress;
    private _licenseState;
    private _schema;
    private _dataPrefixMap;
    constructor(parentId: string, options: FormOptions);
    private setParentElement;
    private initializeOptions;
    private initForm;
    private processLicense;
    buildSchema(schema: Schema, parent: HTMLElement, groupId?: string | null, listId?: string | null, key?: string | null): void;
    private isFormValid;
    private createWrapper;
    private mapFieldToDataPrefix;
    private buildElement;
    private assignToListField;
    update(): Promise<void>;
    getField(id: string): any;
    getFormElement(): HTMLFormElement | null;
    setData(id: string, value: FieldValue): void;
    private setDataFromMap;
    private setSimpleData;
    private ensureDataStructureExists;
    removeListData(listId: string, index: number): void;
    getId(): string;
    getData(): FormData;
    getButtons(): any;
    getButton(id: string): any | undefined;
    getGroups(): any;
    getGroup(id: string): any;
    savesProgress(): boolean;
    hasValidLicense(): boolean;
    updateError(id: string, isValid: boolean | null): void;
    reset(event?: Event): void;
    validate(): void;
    save(): void;
    load(): void;
    onGui(): void;
    private createInvalidElement;
    submit(event: Event, form: Form): void;
}
